<?php

class pns_add_notices_on_cart_class {

   private $pns_general_settings = 'pns_general_settings';
	private $pns_advanced_settings = 'pns_advanced_settings';
	 
	public function __construct() {
	 	$advancedoptions       = (array) get_option( $this->pns_advanced_settings );
	 	global $post;

	 	if (isset($advancedoptions['archive']) && ($advancedoptions['archive'] == "yes")) {
	 		add_action( 'woocommerce_before_shop_loop', array( $this, 'pns_add_cart_notices' ) );
	 	}

	 	if (isset($advancedoptions['product']) && ($advancedoptions['product'] == "yes")) {
	 		add_action( 'woocommerce_before_single_product', array( $this, 'pns_add_cart_notices' ) );
	 	}


	 	add_action( 'woocommerce_before_cart_contents', array( $this, 'pns_add_cart_notices' ) );

	 	add_shortcode('pns_notices', array( $this, 'pns_notices_shortcode_content' ));

	 	if (!isset($advancedoptions['checkout'])) {
	 		add_action( 'woocommerce_checkout_before_customer_details', array( $this, 'pns_add_cart_notices' ) );
	 	}

	}

	public function pns_notices_shortcode_content() {
		ob_start();
      $content = $this->pns_add_cart_notices();
      echo $content;
      return ob_get_clean();
	}
	 
	public function pns_add_cart_notices() {
	    global $woocommerce;
		
		$carttotal         = pns_get_minimum_order_amount();
	   $pns_notices       = (array) get_option( $this->pns_general_settings );
		$cartcontents      = $woocommerce->cart->cart_contents_count;
		
		$html = new pns_cart_notices_text_class();
		if (array($pns_notices) && (sizeof($pns_notices) >= 1)) {
		foreach ($pns_notices as $notice) {
		  if (isset($notice['notice_type']) )
		     $notice_type       = $notice['notice_type'];
		  if (isset($notice['notice_message']) )
		      $message           = $notice['notice_message'];
		  if (isset($notice['notice_buttontext']) )
		     $buttontext        = $notice['notice_buttontext'];
		  if (isset($notice['notice_buttonhref']) )
		    $buttonhref        = $notice['notice_buttonhref'];
		  
		  
		  
		  $notice_visibility = 0;
		  $notice_visibility = $this->check_notice_visibility($notice_visibility,$notice);
		  

		  
		  if ($notice_visibility == 1) {
		    if (isset($notice_type)) {
		    switch ($notice_type) {
			  case "minimumamount": 
			    $message= $html-> minamount_notice_text($notice);
			  break;
			  
			  case "products": 
			    $message= $html->products_notice_text($notice);
			  break;
			  
			  case "category": 
			     $message= $html->category_notice_text($notice);
			  break;
			  
			  case "coupon": 
			     $message= $html->coupon_notice_text($notice);
			  break;
			  
			  case "deadline": 
			     $message= $html->deadline_notice_text($notice);
			  break;
			  
			  
			} 
		  }
		    
		    if (isset($message))
		       $message = str_replace(array('{','}'),'',$message);
		   
		    if (isset($message) && ($message !='')) {
		     if ((isset($buttontext) && ($buttontext !='')) && (isset($buttontext) && ($buttontext !='')) && (isset($buttonhref) && ($buttonhref !=''))) {
			   $noticetext= '<div class="woocommerce-cart-notice woocommerce-info">'.$message.' <a class="button" href="'.$buttonhref.'">'.$buttontext.'</a></div>';
		     } else {
			   $noticetext= '<div class="woocommerce-cart-notice woocommerce-info">'.$message.' </div>';
			 }
			 }
			
			 if (isset($noticetext))
			  echo $noticetext;
		  }
		}
		}
		
	    
		
		
	 }
	 
	 public function check_notice_visibility($notice_visibility,$notice) {
	    global $woocommerce;
		  $carttotal    = pns_get_minimum_order_amount();

		  if (isset($notice['notice_type']))
		     $noticetype   = $notice['notice_type'];
		  
		  $extra        = new pns_conditiona_extra_check();
		  
           if (isset($notice['notice_validity']))
		      $validity     = $notice['notice_validity'];

		   if (isset($notice['notice_visibleto']))
		      $rolerule     = $notice['notice_visibleto'];
		  
		  
		  
		  $is_expired   = "no";

          if (isset($validity))
		    $is_expired   = $extra->check_notice_expiry($validity,$notice);

		  $is_rolevalid = "yes";

          if (isset($rolerule))
		    $is_rolevalid = $extra->check_role_validity($rolerule,$notice);
		  
		  
		 if (($is_expired == "yes") || ($is_rolevalid == "no")) {
		      return 0;
		    } else {
		      $notice_visibility = 1;
		    }


		 
		
		if (isset($noticetype)) {
		switch($noticetype) {
		 case "minimumamount":
		   
		  $minamount         = $notice['notice_minamount'];
		  $threshold         = $notice['notice_threshold'];
		  
		  if (isset($minamount) && ($minamount >0)) { 
		   if ($carttotal < $minamount)  {
		     $notice_visibility = 1;
			} else {
			
		     return 0;
			 
		    }
		  
		  } 
		 
		  if (isset($threshold) && ($threshold >0)) { 
		  
		     if ($carttotal >= $threshold) {
		       $notice_visibility = 1;
			  } else {
			  
			   return 0;
		    }
		  } 
		 break;
		 
		 case "products":
		 
		  if (isset($notice['notice_minquantity']))
	       $requiredquantity    = $notice['notice_minquantity'];
		  
		  if (isset($notice['notice_maxquantity']))
		   $thresholdquantity   = $notice['notice_maxquantity'];
		  
		  if (isset($notice['notice_products']))
		   $allowedproducts     = $notice['notice_products'];
		  
		  $validcartquantity   = 0;
		   
		   foreach ( $woocommerce->cart->cart_contents as $cart_item) {
		         $productid=$cart_item['product_id'];
				 $thisquantity =$cart_item['quantity'];
              
              if (isset($allowedproducts)) {
			      foreach ($allowedproducts as $alloweditem) {
			        if ($alloweditem == $productid) {
			        $validcartquantity = $validcartquantity + $thisquantity ;
			      }
              }
			     }
		        }
		  
		  
	      if (isset($requiredquantity) && ($requiredquantity >0)) { 
		   if ($validcartquantity < $requiredquantity)  {
		     $notice_visibility = 1;
			} else {
			
		     return 0;
			 
		    }
		  
		  } 
		 
		  if (isset($thresholdquantity) && ($thresholdquantity >0)) { 
		  
		     if ($validcartquantity >= $thresholdquantity) {
		       $notice_visibility = 1;
			  } else {
			  
			   return 0;
		    }
		  }
		  
          $productsnum = 0;		  
		  foreach ($woocommerce->cart->cart_contents as $cart_item) {
		    $productid=$cart_item['product_id'];
         
            if (isset($allowedproducts)) {
			foreach ($allowedproducts as $alloweditem) {
			  if ($alloweditem == $productid) {
			    $productsnum++;
			  }
			}
		    }

		  }
		   
		   if ($validcartquantity == 0) {
			    return 0;
			   }
		
		  
	  
		 break;
		 
		  case "category":
		   $requiredquantity    = $notice['notice_minquantity'];
		   $thresholdquantity   = $notice['notice_maxquantity'];
		   $allowedcats         = $notice['notice_category'];
		  
		  $validcartquantity   = 0;
		   foreach ( $woocommerce->cart->cart_contents as $cart_item) {
		         $productid=$cart_item['product_id'];
				 $thisquantity =$cart_item['quantity'];
				 $product_cats_array   = wp_get_post_terms($productid, 'product_cat' , array("fields" => "ids"));
				 
                 				 
					if ((is_array($product_cats_array)) && (sizeof($product_cats_array) >0 )) {
			foreach ($product_cats_array as $product_cat) {
			
			    foreach ($allowedcats as $allowedcat) {
				   if ($product_cat == $allowedcat) {
				    $validcartquantity = $validcartquantity + $thisquantity;
				   }
				 }
			   }
			  }
			  
			  
		     }
		  
	      if (isset($requiredquantity) && ($requiredquantity >0)) { 
		   if ($validcartquantity < $requiredquantity)  {
		     $notice_visibility = 1;
			} else {
			
		     return 0;
			 
		    }
		  
		  } 
		 
		  if (isset($thresholdquantity) && ($thresholdquantity >0)) { 
		  
		     if ($validcartquantity >= $thresholdquantity) {
		       $notice_visibility = 1;
			  } else {
			  
			   return 0;
		    }
		  } 
		  
		     $catsnum = 0;		
          			 
		  foreach ($woocommerce->cart->cart_contents as $cart_item) {
		   
		    $productid            = $cart_item['product_id'];
			$product_cats_array   = wp_get_post_terms($productid, 'product_cat' , array("fields" => "ids"));
			
			if ((is_array($product_cats_array)) && (sizeof($product_cats_array) >0 )) {
			foreach ($product_cats_array as $product_cat) {
			
			    foreach ($allowedcats as $allowedcat) {
				   if ($product_cat == $allowedcat) {
				    $catsnum++;
				   }
				 }
			  
		
			}
		  }
		  }
		   
		   if ($catsnum == 0) {
			    return 0;
			   }
		 break;
		
		 case "coupon":
		  
		  $minamount      = $notice['notice_minamount'];
		  $threshold    = $notice['notice_threshold'];
	       if (isset($minamount) && ($minamount >0)) { 
		   if ($carttotal <= $minamount)  {
		     $notice_visibility = 1;
			} else {
			
		     return 0;
			 
		    }
		  
		  } 
		 
		  if (isset($threshold) && ($threshold >0)) { 
		  
		     if ($carttotal >= $threshold) {
		       $notice_visibility = 1;
			  } else {
			  
			   return 0;
		    }
		  } 
		 break;
		 
		 case "referer":
		   $refererurl    = $notice['notice_referer'];
		   $httpreferer   = $_SERVER['HTTP_REFERER'];
		  
		 if (isset($refererurl) && (substr($httpreferer, 0 - strlen($refererurl)) == $refererurl)) {
		  
		    $notice_visibility = 1;
			
		  } else {
		 
		    return 0;
		  }
		 break;
		 
		 
		 case "deadline":
		    $deadlinetype    = $notice['notice_deadlinetype'];
		   
		   switch($deadlinetype) {
		    case "day":
			  if (isset($notice['notice_days']) ) {
			    $noticedays    = $notice['notice_days'];
			  }
			  
			  if (isset($notice['notice_deadlinehour']) ) {
			    $notice_deadlinehour   = $notice['notice_deadlinehour'];
			   }
			  
			  $bloghour    = date( 'H', current_time( 'timestamp', 0 ) );
			  
			  $blogtime     = date( 'Y-m-d', current_time( 'timestamp', 0 ) );
              $blogday      = date('l', strtotime($blogtime));
			  $blogday      = strtolower ($blogday);
			  $alloweddays  = '';
			   
			   if (isset($noticedays) && is_array($noticedays)) {
				foreach ($noticedays as $day) {
				  $alloweddays.=''.$day.',';
				}
				}
				
			   $alloweddays  =substr_replace( $alloweddays, "", -1);
			    if (!preg_match('/\b'.$blogday.'\b/', $alloweddays )) {
                  return 0;
                }
				
			   if (isset($notice_deadlinehour)) {
				   if ($bloghour >=$notice_deadlinehour) {
					   return 0;
				   }
			   }
			break;
			
			case "date":
			  $blogtime     = date( 'm/d/Y', current_time( 'timestamp', 0 ) );
              
			  if (isset($notice['notice_dates']) ) {
			    $noticedates   = $notice['notice_dates'];
			  }
			  
			  if (isset($notice['notice_deadlinehour']) ) {
			    $notice_deadlinehour   = $notice['notice_deadlinehour'];
			   }
			  
			   $bloghour    = date( 'H', current_time( 'timestamp', 0 ) );
			   $noticedates= explode( ',' , $noticedates );
			   $datenumber=0;
			   foreach ($noticedates as $date) {
                 if ($date == $blogtime)	{
                   $datenumber++;
                }				 
			   }
			   
			   if ($datenumber == 0) {
			    return 0;
			   }
			   
			   if (isset($notice_deadlinehour)) {
				   if ($bloghour >=$notice_deadlinehour) {
					   return 0;
				   }
			   }
			   
			 
			break;
		   }
		 break;
		 
		 
		}

	 }
		return $notice_visibility;
	 }

	 
	 
	
	 
	 
}
new pns_add_notices_on_cart_class();
?>